#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

// #define NDEBUG 1

#ifdef __cplusplus
// ------------------ class.h ----------------------------------------
class intarray {
public:
  // Konstruktoren
  intarray();	// usefull for pointer? without initialization ???
  intarray(unsigned len);			// intarray a(5);
  intarray(unsigned len,char *,int);		// intarray a(5,"a",__LINE__);

  // Destruktor
  ~intarray(){ delete thearray; }

  // Elementzugriff
  int & operator[](unsigned);			// a[4]=7;

  int querylen(){ return length; }		// cout << a.querylen();

private:
  // pointer to memory
  int *thearray;
  unsigned length;
#if !defined(NDEBUG)
  char name[8];
  int line;
#endif
}; // intarray

// ------------------ class.c ----------------------------------------
intarray::intarray(){
  length=0;
  thearray = NULL;
#if !defined(NDEBUG)
  printf("constructor: %p %p\n",this,thearray);
#endif
}
intarray::intarray(unsigned len){
  length=len;
  thearray = new int[len];
#if !defined(NDEBUG)
  printf("constructor: %p %p len=%d\n",this,thearray,len);
#endif
}

intarray::intarray(unsigned len,char *name,int line){
  length=len;
  thearray = new int[len];
#if !defined(NDEBUG)
  printf("constructor: %p %p %s[%d]\n",this,thearray,name,len);
  for(int i=0;i<8;i++)intarray::name[i]=name[i];intarray::name[7]=0;
  intarray::line=line;
#endif
}

int & intarray::operator[](unsigned i){
#if !defined(NDEBUG)
   printf(" %p:%p[%d]\n",this,thearray,i);
   if(i>=length) printf("ArrayOVL %s L%d i=%d l=%d\n",name,line,i,length);
   assert(i<length);	// !assert && !defined(NDEBUG) => ERROR
#endif
   return thearray[i];
}
// --------------------- end-of-class --------------------------------

// use the following definition for declarations of arrays
#define IntArray(name,len)  intarray name(len,#name,__LINE__)
#else /* no C++, only c */
#define IntArray(name,len)  int name[len]
#endif 

int main(){
  IntArray(a,5);  // intarray a(5);
  IntArray(b,8);  // intarray b(8);
  int i;
  intarray c[3];
  printf(" sizeof(class intarray)=%d\n",sizeof(class intarray));
  for(i=0;i<5;i++)a[i]=i*3;
  for(i=0;i<8;i++)b[i]=i*2;
  printf( "Hello-test %d\n", a[3]);
  printf( "Hello-test %d\n", b[3]);
  printf( "Hello-test %d\n", a.querylen());
  printf( "Hello-test %d\n", b.querylen());
  b[8]=0;
}
